"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _immutabilityHelper = require("immutability-helper");

var _immutabilityHelper2 = _interopRequireDefault(_immutabilityHelper);

var _VirtualSchemaField = require("../VirtualSchemaField");

var _VirtualSchemaField2 = _interopRequireDefault(_VirtualSchemaField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Sets given default values to target fields.
 * uiSchema = { "ui:options": {
 *  "default": [
 *    {
 *      field1: defaultValue1,
 *      field2: defaultValue2
 *    }
 *    ...
 *  ]
 * }}
 */
var DefaultValueArrayField = (0, _VirtualSchemaField2.default)(_class = function (_Component) {
	(0, _inherits3.default)(DefaultValueArrayField, _Component);

	function DefaultValueArrayField() {
		(0, _classCallCheck3.default)(this, DefaultValueArrayField);
		return (0, _possibleConstructorReturn3.default)(this, (DefaultValueArrayField.__proto__ || (0, _getPrototypeOf2.default)(DefaultValueArrayField)).apply(this, arguments));
	}

	(0, _createClass3.default)(DefaultValueArrayField, [{
		key: "onChange",
		value: function onChange(formData) {
			var options = this.getUiOptions();
			var _default = options.default;

			(0, _keys2.default)(_default).forEach(function (field) {
				if (formData) formData.forEach(function (item, i) {
					formData = (0, _immutabilityHelper2.default)(formData, { $splice: [[i, 1, (0, _immutabilityHelper2.default)(item, { $merge: (0, _defineProperty3.default)({}, field, _default[field]) })]] });
				});
			});
			this.props.onChange(formData);
		}
	}], [{
		key: "getName",
		value: function getName() {
			return "DefaultValueArrayField";
		}
	}]);
	return DefaultValueArrayField;
}(_react.Component)) || _class;

DefaultValueArrayField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			default: _propTypes2.default.object.isRequired
		}).isRequired
	}).isRequired,
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["array"])
	}).isRequired,
	formData: _propTypes2.default.oneOfType([_propTypes2.default.array]).isRequired
};
exports.default = DefaultValueArrayField;